import CodeMirror, { Mode } from 'codemirror';
import 'codemirror/mode/xml/xml';
declare module 'codemirror' {
    function copyState<T = any>(mode: any, state: T): T;
    function registerGlobalHelper(type: string, name: string, predicate: (mode: CodeMirror.Mode<any>, cm: CodeMirror.Editor) => boolean, value: any): void;
}
export interface IXmlMixedOptions {
    decideMode?: (tag: ITag) => any;
    xmlOptions?: {
        htmlMode?: boolean;
        autoSelfClosers?: {
            [tag: string]: boolean;
        };
        implicitlyClosed?: {
            [tag: string]: boolean;
        };
        contextGrabbers?: {
            [tag: string]: {
                [key: string]: boolean;
            };
        };
        doNotIndent?: {
            [tag: string]: boolean;
        };
        allowUnquoted?: boolean;
        allowMissing?: boolean;
        allowMissingTagName?: boolean;
        caseFold?: boolean;
        multilineTagIndentFactor?: number;
        multilineTagIndentPastTag?: boolean;
        alignCDATA?: boolean;
    };
}
interface ITag {
    name: string;
    attributes: {
        [property: string]: string;
    };
    mode?: Mode<any>;
}
export declare function defaultDecideMode(ignored: ITag): any;
export {};
